package com.example.AI.controller;

import com.example.AI.modal.*;
import com.example.AI.service.FruitService;
import com.example.AI.service.PersonService;
import com.example.AI.service.VegetableService;
import com.example.AI.service.VehicleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api")
@CrossOrigin
public class controller {
    @Autowired
    private PersonService personService;
    @Autowired
    private FruitService fruitService;
    @Autowired
    private VegetableService vegetableService;
    @Autowired
    private VehicleService vehicleService;

    @PostMapping("/identify")
    public String identifyEntity(@RequestBody EntityRequest request) {
        try {
            return switch (request.getEntityType()) {
                case "person" -> personService.identifyPerson(request.getPerson());
                case "fruit" -> fruitService.identifyFruit(request.getFruit());
                case "vehicle" -> vehicleService.identifyVehicle(request.getVehicle());
                case "vegetable" -> vegetableService.identifyVegetable(request.getVegetable());
                default -> "Invalid entity type";
            };
        } catch (Exception e) {
            e.printStackTrace(); // Log the exception
            return "Error processing request";
        }
    }

}
