import React, { useState } from 'react';
import Swal from 'sweetalert2';
import './UniFiedForm.css';
// import bootstrap
import 'bootstrap';
import 'bootstrap/dist/css/bootstrap.min.css';
// Hardcoded image URLs for fruits
const fruitImages = {
    apple: 'https://upload.wikimedia.org/wikipedia/commons/1/15/Red_Apple.jpg',
    banana: 'https://upload.wikimedia.org/wikipedia/commons/8/8a/Banana-Single.jpg',
    orange: 'https://upload.wikimedia.org/wikipedia/commons/c/c4/Orange-Fruit-Pieces.jpg',
    watermelon: 'https://upload.wikimedia.org/wikipedia/commons/f/f4/Watermelon_cross_BNC.jpg',
    mango: 'https://upload.wikimedia.org/wikipedia/commons/9/90/Hapus_Mango.jpg',
    pineapple: 'https://upload.wikimedia.org/wikipedia/commons/c/cb/Pineapple_and_cross_section.jpg',
    grapes: 'https://upload.wikimedia.org/wikipedia/commons/1/1e/Grapes_bunches.jpg',
    strawberry: 'https://upload.wikimedia.org/wikipedia/commons/2/29/PerfectStrawberry.jpg',
    peach: 'https://upload.wikimedia.org/wikipedia/commons/d/d6/Peach_1.jpg',
    pear: 'https://upload.wikimedia.org/wikipedia/commons/3/31/Comice_Pear.jpg',
    blueberry: 'https://upload.wikimedia.org/wikipedia/commons/7/79/Blueberries.jpg',
    raspberry: 'https://upload.wikimedia.org/wikipedia/commons/7/75/Raspberries05.jpg',
    kiwi: 'https://upload.wikimedia.org/wikipedia/commons/d/d3/Kiwi_aka.jpg',
    lemon: 'https://upload.wikimedia.org/wikipedia/commons/4/4c/Lemon.jpg',
    lime: 'https://upload.wikimedia.org/wikipedia/commons/5/5f/Limes.jpg',
    papaya: 'https://upload.wikimedia.org/wikipedia/commons/8/8e/Papaya_cross_section_bnc.jpg',
    pomegranate: 'https://upload.wikimedia.org/wikipedia/commons/f/f7/Pomegranate_fruit_-_whole_and_seeds.jpg',
    cherry: 'https://upload.wikimedia.org/wikipedia/commons/b/bb/Cherry_Stella444.jpg',
    coconut: 'https://upload.wikimedia.org/wikipedia/commons/6/6f/Coconut.jpg'
};
const vegetableImages = {
    carrot: 'https://upload.wikimedia.org/wikipedia/commons/7/7d/Carrot.jpg',
    potato: 'https://upload.wikimedia.org/wikipedia/commons/a/ab/Patates.jpg',
    tomato: 'https://upload.wikimedia.org/wikipedia/commons/8/88/Bright_red_tomato_and_cross_section02.jpg',
    cucumber: 'https://upload.wikimedia.org/wikipedia/commons/9/9b/Cucumis_sativus.jpg',
    broccoli: 'https://upload.wikimedia.org/wikipedia/commons/0/03/Broccoli_and_cross_section.jpg',
    lettuce: 'https://upload.wikimedia.org/wikipedia/commons/8/82/Iceberg_lettuce_in_SB.jpg',
    onion: 'https://upload.wikimedia.org/wikipedia/commons/5/5b/Onion.jpg',
    garlic: 'https://upload.wikimedia.org/wikipedia/commons/8/87/Garlic_Single_Clove.jpg',
    spinach: 'https://upload.wikimedia.org/wikipedia/commons/4/49/Spinacia_oleracea_Spinazie_bloeiend.jpg',
    zucchini: 'https://upload.wikimedia.org/wikipedia/commons/e/e2/Zucchini_with_flower.jpg',
    eggplant: 'https://upload.wikimedia.org/wikipedia/commons/a/a0/Eggplants.jpg',
    bellPepper: 'https://upload.wikimedia.org/wikipedia/commons/6/67/Red_pepper.jpg',
    corn: 'https://upload.wikimedia.org/wikipedia/commons/a/ae/Corn-on-the-cob.jpg',
    cabbage: 'https://upload.wikimedia.org/wikipedia/commons/f/f9/Cabbage_and_cross_section.jpg',
    pumpkin: 'https://upload.wikimedia.org/wikipedia/commons/2/2e/Two_pumpkins.jpg',
    beetroot: 'https://upload.wikimedia.org/wikipedia/commons/8/89/Table_beetroot.jpg'
};
const vehicleImages = {
    car: 'https://upload.wikimedia.org/wikipedia/commons/6/6b/Example_of_a_small_car.jpg',
    bike: 'https://upload.wikimedia.org/wikipedia/commons/1/17/Bicycle-parts-labeled-en.jpg',
    bus: 'https://upload.wikimedia.org/wikipedia/commons/f/fb/Bus_in_Athens.jpg',
    truck: 'https://upload.wikimedia.org/wikipedia/commons/5/58/Example_of_a_truck.jpg',
    motorcycle: 'https://upload.wikimedia.org/wikipedia/commons/e/e7/Motorcycle_side_view.jpg',
    scooter: 'https://upload.wikimedia.org/wikipedia/commons/5/50/Scooter_moto.jpg',
    van: 'https://upload.wikimedia.org/wikipedia/commons/9/9d/White_van.jpg',
    train: 'https://upload.wikimedia.org/wikipedia/commons/4/47/Train_Picture.jpg',
    airplane: 'https://upload.wikimedia.org/wikipedia/commons/e/e4/Airplane_in_the_sky.jpg',
    helicopter: 'https://upload.wikimedia.org/wikipedia/commons/3/3f/Helicopter_side_view.jpg',
    boat: 'https://upload.wikimedia.org/wikipedia/commons/3/34/Boat_in_Sea.jpg',
    tractor: 'https://upload.wikimedia.org/wikipedia/commons/7/7b/Tractor_Farm.jpg',
    ship: 'https://upload.wikimedia.org/wikipedia/commons/4/49/Container_Ship.jpg',
    submarine: 'https://upload.wikimedia.org/wikipedia/commons/5/51/Submarine_in_harbor.jpg'
};

const personImages = {
    sundar: 'https://upload.wikimedia.org/wikipedia/commons/9/99/Headshot_of_a_man.jpg',
    mirza: 'https://upload.wikimedia.org/wikipedia/commons/7/71/Woman_Headshot.jpg',
    other: 'https://upload.wikimedia.org/wikipedia/commons/7/75/Gender_neutral_icon.png', // Gender neutral placeholder
};
// Map of fruit names to images for random fruit selection
// const getFruitImage = (fruitName) => fruitImages[fruitName.toLowerCase()] || 'https://via.placeholder.com/150'; // Default image
const getFruitImage = (fruitName) => fruitImages[fruitName.toLowerCase()] || 'https://via.placeholder.com/150';
const getVegetableImage = (vegetableName) => vegetableImages[vegetableName.toLowerCase()] || 'https://via.placeholder.com/150';
const getVehicleImage = (vehicleType) => vehicleImages[vehicleType.toLowerCase()] || 'https://via.placeholder.com/150';
const getPersonImage = (personType) => personImages[personType.toLowerCase()] || 'https://via.placeholder.com/150';

const UnifiedForm = () => {
    const [entity, setEntity] = useState('');
    const [fruit, setFruit] = useState({ size: '', insideColor: '', outsideColor: '', shape: '', taste: '' });
    const [person, setPerson] = useState({ age: '', looks: '', nature: '', height: '', intelligence: '' });
    const [vegetable, setVegetable] = useState({ size: '', insideColor: '', outsideColor: '', shape: '', taste: '' });
    const [vehicle, setVehicle] = useState({ type: '', size: '', noOfWheels: '', passengerCapacity: '', shape: '', speed: '' });

    const handleFruitChange = (e) => setFruit({ ...fruit, [e.target.name]: e.target.value });
    const handlePersonChange = (e) => setPerson({ ...person, [e.target.name]: e.target.value });
    const handleVegetableChange = (e) => setVegetable({ ...vegetable, [e.target.name]: e.target.value });
    const handleVehicleChange = (e) => setVehicle({ ...vehicle, [e.target.name]: e.target.value });

    const handleSubmit = async (e) => {
        e.preventDefault();
    
        if (!entity) {
            Swal.fire('Error', 'Please select an entity!', 'error');
            return;
        }
    
        const requestBody = {
            entityType: entity.toLowerCase(),
            [entity.toLowerCase()]: { fruit, person, vegetable, vehicle }[entity.toLowerCase()],
        };
    
        try {
            const response = await fetch('http://localhost:8080/api/identify', {
                method: 'POST',
                headers: { 'Content-Type': 'application/json' },
                body: JSON.stringify(requestBody),
            });
    
            if (!response.ok) throw new Error(`HTTP error! status: ${response.status}`);
    
            const result = await response.text(); // Read response as text
    
            // Ensure result is not empty
            const name = result ? result.trim() : ''; // Trim any extra spaces from result
    
            // Handle undefined or empty name
            if (!name) {
                Swal.fire('Error', 'No name identified!', 'error');
                return;
            }
    
            // Use hardcoded fruit images if it's a fruit entity
            let imageUrl = '';

        if (entity === 'Fruit') {
            imageUrl = getFruitImage(name);
        } else if (entity === 'Vegetable') {
            imageUrl = getVegetableImage(name);
        } else if (entity === 'Person') {
            // Assuming the server returns 'male', 'female', or 'other' for person type
            imageUrl = getPersonImage(name);
        } else if (entity === 'Vehicle') {
            imageUrl = getVehicleImage(name);
        }

        Swal.fire({
            title: `Identified: ${name}`,
            text: 'Here are the details of your submission',
            imageUrl: imageUrl || 'https://via.placeholder.com/150',
            imageWidth: 400,
            imageHeight: 200,
            imageAlt: `${name} Image`,
            confirmButtonText: 'Cool',
        });
        } catch (error) {
            console.error("Error:", error);
            Swal.fire('Error', 'Submission failed!', 'error');
        }
    };
    
    return (
        <div className="form-container bg-transparent">
            <form onSubmit={handleSubmit}>
                <div className="entity-selector">
                    <label>Select Entity</label>
                    <select
                        className="form-select"
                        onChange={(e) => setEntity(e.target.value)}
                        value={entity}
                    >
                        <option value="">Select the Entity</option>
                        <option value="Fruit">Fruit</option>
                        <option value="Person">Person</option>
                        <option value="Vegetable">Vegetable</option>
                        <option value="Vehicle">Vehicle</option>
                    </select>
                </div>
                {entity === 'Fruit' && (
                    <div className='fruitSelector'>
                        {/* Fruit Size */}
                        <div className='fruitsizeSelector'>
                            <select
                                className="form-select"
                                name="size"
                                value={fruit.size}
                                onChange={handleFruitChange}
                                aria-label="Select the size"
                            >
                                <option value="">Select the size</option>
                                <option value="big">Big</option>
                                <option value="small">Small</option>
                                <option value="medium">Medium</option>
                                <option value="large">Large</option>
                            </select>
                        </div>
                        {/* Fruit Inside Color */}
                        <div className='fruitinsideSelector'>
                            <select
                                className="form-select"
                                name="insideColor"
                                value={fruit.insideColor}
                                onChange={handleFruitChange}
                                aria-label="Select the inside color"
                            >
                                <option value="">Select the inside color</option>
                                <option value="red">Red</option>
                                <option value="green">Green</option>
                                <option value="white">White</option>
                                <option value="orange">Orange</option>
                                <option value="purple">Purple</option>
                                <option value="yellow">Yellow</option>
                            </select>
                        </div>
                        {/* Fruit Outside Color */}
                        <div className='fruitoutsideSelector'>
                            <select
                                className="form-select"
                                name="outsideColor"
                                value={fruit.outsideColor}
                                onChange={handleFruitChange}
                                aria-label="Select the outside color"
                            >
                                <option value="">Select the outside color</option>
                                <option value="green">Green</option>
                                <option value="yellow">Yellow</option>
                                <option value="red">Red</option>
                                <option value="brown">Brown</option>
                                <option value="purple">Purple</option>
                            </select>
                        </div>
                        {/* Fruit Shape */}
                        <div className='fruitshapeSelector'>
                            <select
                                className="form-select"
                                name="shape"
                                value={fruit.shape}
                                onChange={handleFruitChange}
                                aria-label="Select the shape"
                            >
                                <option value="">Select the shape</option>
                                <option value="round">Round</option>
                                <option value="oval">Oval</option>
                                <option value="elongated">Elongated</option>
                                <option value="spiky">Spiky</option>
                                <option value="heart-shaped">Heart-shaped</option>
                            </select>
                        </div>
                        {/* Fruit Taste */}
                        <div className='fruittasteSelector'>
                            <select
                                className="form-select"
                                name="taste"
                                value={fruit.taste}
                                onChange={handleFruitChange}
                                aria-label="Select the taste"
                            >
                                <option value="">Select the taste</option>
                                <option value="sweet">Sweet</option>
                                <option value="tart">Tart</option>
                                <option value="citrus">Citrus</option>
                            </select>
                        </div>
                    </div>
                )}

                {entity === 'Person' && (
                    <div className='personSelector'>
                        {/* Person Age */}
                        <div className='personAgeSelector'>
                            <select
                                className="form-select"
                                name="age"
                                value={person.age}
                                onChange={handlePersonChange}
                                aria-label="Select the age"
                            >
                                <option value="">Select the age</option>
                                <option value="child">Child</option>
                                <option value="teen">Teen</option>
                                <option value="young">Young</option>
                                <option value="adult">Adult</option>
                                <option value="elderly">Elderly</option>
                            </select>
                        </div>
                        {/* Person Looks */}
                        <div className='personLooksSelector'>
                            <select
                                className="form-select"
                                name="looks"
                                value={person.looks}
                                onChange={handlePersonChange}
                                aria-label="Select the looks"
                            >
                                <option value="">Select the looks</option>
                                <option value="smart">Smart</option>
                                <option value="cute">Cute</option>
                                <option value="handsome">Handsome</option>
                                <option value="charming">Charming</option>
                                <option value="stylish">Stylish</option>
                                <option value="adorable">Adorable</option>
                                <option value="wise">Wise</option>
                                <option value="professional">Professional</option>
                            </select>
                        </div>
                        {/* Person Nature */}
                        <div className='personNatureSelector'>
                            <select
                                className="form-select"
                                name="nature"
                                value={person.nature}
                                onChange={handlePersonChange}
                                aria-label="Select the nature"
                            >
                                <option value="">Select the nature</option>
                                <option value="cool">Cool</option>
                                <option value="innocent">Innocent</option>
                                <option value="aggressive">Aggressive</option>
                                <option value="friendly">Friendly</option>
                                <option value="playful">Playful</option>
                                <option value="calm">Calm</option>
                                <option value="energetic">Energetic</option>
                                <option value="rebellious">Rebellious</option>
                                <option value="curious">Curious</option>
                                <option value="shy">Shy</option>
                            </select>
                        </div>
                        {/* Person Height */}
                        <div className='personHeightSelector'>
                            <select
                                className="form-select"
                                name="height"
                                value={person.height}
                                onChange={handlePersonChange}
                                aria-label="Select the height"
                            >
                                <option value="">Select the height</option>
                                <option value="short">Short</option>
                                <option value="average">Average</option>
                                <option value="tall">Tall</option>
                            </select>
                        </div>
                        {/* Person Intelligence */}
                        <div className='personIntelligenceSelector'>
                            <select
                                className="form-select"
                                name="intelligence"
                                value={person.intelligence}
                                onChange={handlePersonChange}
                                aria-label="Select the intelligence"
                            >
                                <option value="">Select the intelligence</option>
                                <option value="high">High</option>
                                <option value="average">Average</option>
                                <option value="low">Low</option>
                            </select>
                        </div>
                    </div>
                )}

                {entity === 'Vegetable' && (
                    <div className='vegetableSelector'>
                        {/* Vegetable Size */}
                        <div className='vegetableSizeSelector'>
                            <select
                                className="form-select"
                                name="size"
                                value={vegetable.size}
                                onChange={handleVegetableChange}
                                aria-label="Select the size"
                            >
                                <option value="">Select the size</option>
                                <option value="big">Big</option>
                                <option value="small">Small</option>
                                <option value="medium">Medium</option>
                                <option value="large">Large</option>
                            </select>
                        </div>
                        {/* Vegetable Inside Color */}
                        <div className='vegetableInsideColorSelector'>
                            <select
                                className="form-select"
                                name="insideColor"
                                value={vegetable.insideColor}
                                onChange={handleVegetableChange}
                                aria-label="Select the inside color"
                            >
                                <option value="">Select the inside color</option>
                                <option value="red">Red</option>
                                <option value="green">Green</option>
                                <option value="white">White</option>
                                <option value="orange">Orange</option>
                                <option value="purple">Purple</option>
                                <option value="yellow">Yellow</option>
                            </select>
                        </div>
                        {/* Vegetable Outside Color */}
                        <div className='vegetableOutsideColorSelector'>
                            <select
                                className="form-select"
                                name="outsideColor"
                                value={vegetable.outsideColor}
                                onChange={handleVegetableChange}
                                aria-label="Select the outside color"
                            >
                                <option value="">Select the outside color</option>
                                <option value="green">Green</option>
                                <option value="yellow">Yellow</option>
                                <option value="red">Red</option>
                                <option value="brown">Brown</option>
                                <option value="purple">Purple</option>
                            </select>
                        </div>
                        {/* Vegetable Shape */}
                        <div className='vegetableShapeSelector'>
                            <select
                                className="form-select"
                                name="shape"
                                value={vegetable.shape}
                                onChange={handleVegetableChange}
                                aria-label="Select the shape"
                            >
                                <option value="">Select the shape</option>
                                <option value="round">Round</option>
                                <option value="oval">Oval</option>
                                <option value="elongated">Elongated</option>
                                <option value="spiky">Spiky</option>
                                <option value="heart-shaped">Heart-shaped</option>
                            </select>
                        </div>
                        {/* Vegetable Taste */}
                        <div className='vegetableTasteSelector'>
                            <select
                                className="form-select"
                                name="taste"
                                value={vegetable.taste}
                                onChange={handleVegetableChange}
                                aria-label="Select the taste"
                            >
                                <option value="">Select the taste</option>
                                <option value="sweet">Sweet</option>
                                <option value="bitter">Bitter</option>
                                <option value="savory">Savory</option>
                                <option value="spicy">Spicy</option>
                            </select>
                        </div>
                    </div>
                )}

                {entity === 'Vehicle' && (
                    <div className='vehicleSelector'>
                        {/* Vehicle Type */}
                        <div className='vehicleTypeSelector'>
                            <select
                                className="form-select"
                                name="type"
                                value={vehicle.type}
                                onChange={handleVehicleChange}
                                aria-label="Select the type"
                            >
                                <option value="">Select the type</option>
                                <option value="car">Car</option>
                                <option value="truck">Truck</option>
                                <option value="motorcycle">Motorcycle</option>
                                <option value="bicycle">Bicycle</option>
                            </select>
                        </div>
                        {/* Vehicle Size */}
                        <div className='vehicleSizeSelector'>
                            <select
                                className="form-select"
                                name="size"
                                value={vehicle.size}
                                onChange={handleVehicleChange}
                                aria-label="Select the size"
                            >
                                <option value="">Select the size</option>
                                <option value="small">Small</option>
                                <option value="medium">Medium</option>
                                <option value="large">Large</option>
                            </select>
                        </div>
                        {/* Vehicle Number of Wheels */}
                        <div className='vehicleNoOfWheelsSelector'>
                            <select
                                className="form-select"
                                name="noOfWheels"
                                value={vehicle.noOfWheels}
                                onChange={handleVehicleChange}
                                aria-label="Select the number of wheels"
                            >
                                <option value="">Select the number of wheels</option>
                                <option value="2">2</option>
                                <option value="4">4</option>
                                <option value="6">6</option>
                                <option value="8">8</option>
                            </select>
                        </div>
                        {/* Vehicle Passenger Capacity */}
                        <div className='vehiclePassengerCapacitySelector'>
                            <select
                                className="form-select"
                                name="passengerCapacity"
                                value={vehicle.passengerCapacity}
                                onChange={handleVehicleChange}
                                aria-label="Select the passenger capacity"
                            >
                                <option value="">Select the passenger capacity</option>
                                <option value="1-2">1-2</option>
                                <option value="3-4">3-4</option>
                                <option value="5-6">5-6</option>
                                <option value="7-8">7-8</option>
                                <option value="9+">9+</option>
                            </select>
                        </div>
                        {/* Vehicle Shape */}
                        <div className='vehicleShapeSelector'>
                            <select
                                className="form-select"
                                name="shape"
                                value={vehicle.shape}
                                onChange={handleVehicleChange}
                                aria-label="Select the shape"
                            >
                                <option value="">Select the shape</option>
                                <option value="compact">Compact</option>
                                <option value="sedan">Sedan</option>
                                <option value="SUV">SUV</option>
                                <option value="truck">Truck</option>
                                <option value="hatchback">Hatchback</option>
                            </select>
                        </div>
                        {/* Vehicle Speed */}
                        <div className='vehicleSpeedSelector'>
                            <select
                                className="form-select"
                                name="speed"
                                value={vehicle.speed}
                                onChange={handleVehicleChange}
                                aria-label="Select the speed"
                            >
                                <option value="">Select the speed</option>
                                <option value="slow">Slow</option>
                                <option value="average">Average</option>
                                <option value="fast">Fast</option>
                                <option value="very fast">Very Fast</option>
                            </select>
                        </div>
                    </div>
                )}

                <button type="submit" className="btn btn-primary">Submit</button>
            </form>
            {/* {responseText && (
            <div className="response">
                <h3>Server Response:</h3>
                <p>{responseText}</p>
            </div> */}
        {/* )} */}
        </div>
        
    );
};

export default UnifiedForm;
